// TWAINDotNet.cpp : CTWAINDotNet ̎

#include "stdafx.h"
#include "TWAINDotNet.h"
#include "WindowThread.h"


// CTWAINDotNet


STDMETHODIMP CTWAINDotNet::Scan(SAFEARRAY** ppArray)
{
	WindowThread wnd;
	wnd.Create();
	wnd.Join();

	if ( wnd.hBitmap ) {
		LPBYTE p = (LPBYTE)GlobalLock( wnd.hBitmap );
		BITMAPINFOHEADER *bmi = (BITMAPINFOHEADER*)p;

		if (bmi->biSizeImage == 0)
			bmi->biSizeImage = ((((bmi->biWidth * bmi->biBitCount) + 31) & ~31) >> 3) * abs(bmi->biHeight);
		if ((bmi->biClrUsed == 0) && (bmi->biBitCount < 16))
			bmi->biClrUsed = 1 << bmi->biBitCount;

		BITMAPFILEHEADER bmfh = {0};
		bmfh.bfType = 'MB';
		bmfh.bfOffBits = sizeof(BITMAPFILEHEADER) + bmi->biSize + bmi->biClrUsed * 4;
		bmfh.bfSize = bmfh.bfOffBits + bmi->biSizeImage;

		SAFEARRAYBOUND rgaBound[1];
		rgaBound[0].lLbound = 0;
		rgaBound[0].cElements = bmfh.bfSize;

		HRESULT hr = S_OK;
		*ppArray = SafeArrayCreate(VT_UI1, 1, rgaBound);   
		if(ppArray == NULL) return S_FALSE;

		BYTE *pData;
		SafeArrayAccessData(*ppArray, (void**)&pData);

		memcpy_s( pData, bmfh.bfSize, &bmfh, sizeof(BITMAPFILEHEADER) );
		memcpy_s( pData + sizeof(BITMAPFILEHEADER), bmfh.bfSize - sizeof(BITMAPFILEHEADER), p, bmfh.bfSize - sizeof(BITMAPFILEHEADER) );

		SafeArrayUnaccessData(*ppArray);
		GlobalUnlock( wnd.hBitmap );
		GlobalFree( wnd.hBitmap );
	}

	return S_OK;
}

