#include "stdafx.h"
#include "WindowThread.h"
#include "misc.h"
#include "resource.h"

void ScanBitmap(TW_UINT32 twBitmap, void* param1, void* param2)
{
	WindowThread* pWnd = (WindowThread*)param1;
	pWnd->hBitmap = (HGLOBAL)twBitmap;
}


BOOL CALLBACK EnumProc(HWND hWnd , LPARAM lp)
{
	Window* pWnd = (Window*)lp;
	if ( GetParent( hWnd ) == pWnd->m_hWnd ) {
		PostMessage( hWnd, WM_CLOSE, 0, 0 );
	}
	return TRUE;
}

WindowThread::WindowThread(void)
	: bSelectScanner( FALSE )
{
	m_lpszClass = _T("WindowThread");
	twainMan.InitTWAIN();
}

WindowThread::~WindowThread(void)
{
}

BOOL WindowThread::Create(void)
{
	return Thread::Create();
}

DWORD WindowThread::ThreadProc(void)
{
	Window::Create( _T("DummyWindow"), 10, 10, 400, 300, SW_HIDE, NULL );
	return RunMsgLoop();
}

INT_PTR WindowThread::PreTranslateMessage( HWND hWnd, MSG *msg )
{
	return twainMan.TranslateMessage( hWnd, msg );
}

INT_PTR CALLBACK WindowThread::WndProc( UINT message, WPARAM wParam, LPARAM lParam )
{
	int wmId, wmEvent;
	MSG msg;
	HMENU hMenu, hPopup;
	POINT pt;
	BOOL bRet;

	switch (message)
	{
	case WM_COMMAND:
		wmId	= LOWORD(wParam);
		wmEvent = HIWORD(wParam);
		// Iꂽj[̉:

		switch (wmId)
		{
		case ID_POPUP_SELECT:
			bSelectScanner = TRUE;
			bRet = EnumWindows( EnumProc, (LPARAM)this );
			break;

		default:
			return DefWindowProc(m_hWnd, message, wParam, lParam);
		}
		break;

	case WM_TWAIN_CLOSEDS:
		if ( bSelectScanner ) {
			bSelectScanner = FALSE;
			twainMan.SelectScaner( m_hWnd );
			twainMan.Scan( m_hWnd, ScanBitmap, this, NULL );
		}
		else {
			DestroyWindow( m_hWnd );
		}
		break;

	case WM_TWAIN_COMPLETE:
		DestroyWindow( m_hWnd );
		break;

	case WM_CREATE:
		InitTaskbarMessage();
		SetTrayIcon( m_hWnd, TRAY_ADD, szTitle, IDI_ICON_APP );
		twainMan.Scan( m_hWnd, ScanBitmap, this, NULL );
		break;

	case WM_DESTROY:
		SetTrayIcon( m_hWnd, TRAY_DELETE, szTitle, IDI_ICON_APP );
		PostQuitMessage(0);
		twainMan.ExitTWAIN();
		break;

	case WM_TRAYICONMESSAGE:
		switch( lParam )
		{
		case WM_RBUTTONDOWN:
			SetForegroundWindow( m_hWnd );

			hMenu = LoadMenu( hInst, MAKEINTRESOURCE(IDR_MENU1) );
			hPopup = GetSubMenu( hMenu, 0 );

			GetCursorPos( &pt );
			TrackPopupMenu( hPopup, TPM_LEFTALIGN | TPM_RIGHTBUTTON, pt.x, pt.y, NULL, m_hWnd, NULL );

			if ( PeekMessage( &msg, NULL, 0, 0, PM_REMOVE ) ) {
				TranslateMessage( &msg );
				DispatchMessage( &msg );
			}

			DestroyMenu( hMenu );
			return TRUE;
			break;
		}
		break;

	case WM_CLOSE:
		DestroyWindow( m_hWnd );
		break;

	default:
		return DefWindowProc(m_hWnd, message, wParam, lParam);
	}
	return 0;
}

BOOL WindowThread::Exit( DWORD dwTimeout )
{
	PostMessage( m_hWnd, WM_CLOSE, 0, 0 );
	//DestroyWindow( m_hWnd );
	return Thread::Join();
}
