﻿using System;
using System.Collections.Generic;
using System.Text;
using PaintDotNet;
using PaintDotNet.Data;
using System.IO;
using System.Drawing;
using System.Windows.Forms;
using System.Drawing.Imaging;

namespace pdtwain
{
    public class MyFileType : FileType
    {
        public MyFileType()
            : base("TWAIN Input",
                FileTypeFlags.SupportsLoading,
                new String[] { ".pdtwain" })
        {
        }

        protected override Document OnLoad(Stream input)
        {
            try
            {
                byte[] buf;
                TWAINLocalServerLib.TWAINDotNet twain = new TWAINLocalServerLib.TWAINDotNet();
                twain.Scan(out buf);
                if (buf.Length > 0)
                {
                    Bitmap bmp = new Bitmap(new MemoryStream(buf));
                    return Document.FromImage(bmp);
                }
                else return null;
            }
            catch
            {
                MessageBox.Show("Problem Importing File");
                return null;
            }
        }
    }

    public class MyFileTypeFactory : IFileTypeFactory
    {
        public FileType[] GetFileTypeInstances()
        {
            return new FileType[] { new MyFileType() };
        }
    }
}
